/* dasep.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "dasep.h"

void *dasepStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dasepEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dasepDasepSave(struct dasepDasep *obj, int indent, FILE *f)
/* Save dasepDasep to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASEP>");
fprintf(f, "\n");
dasepEntryPointsSave(obj->dasepEntryPoints, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASEP>\n");
}

struct dasepDasep *dasepDasepLoad(char *fileName)
/* Load dasepDasep from file. */
{
struct dasepDasep *obj;
xapParseAny(fileName, "DASEP", dasepStartHandler, dasepEndHandler, NULL, &obj);
return obj;
}

void dasepEntryPointsSave(struct dasepEntryPoints *obj, int indent, FILE *f)
/* Save dasepEntryPoints to file. */
{
struct dasepSegment *dasepSegment;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<ENTRY_POINTS");
fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, " version=\"%s\"", obj->version);
if (obj->id != NULL)
    fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "\n");
for (dasepSegment = obj->dasepSegment; dasepSegment != NULL; dasepSegment = dasepSegment->next)
   dasepSegmentSave(dasepSegment, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</ENTRY_POINTS>\n");
}

struct dasepEntryPoints *dasepEntryPointsLoad(char *fileName)
/* Load dasepEntryPoints from file. */
{
struct dasepEntryPoints *obj;
xapParseAny(fileName, "ENTRY_POINTS", dasepStartHandler, dasepEndHandler, NULL, &obj);
return obj;
}

void dasepSegmentSave(struct dasepSegment *obj, int indent, FILE *f)
/* Save dasepSegment to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SEGMENT");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%s\"", obj->start);
fprintf(f, " stop=\"%s\"", obj->stop);
fprintf(f, " orientation=\"%s\"", obj->orientation);
if (obj->subparts != NULL)
    fprintf(f, " subparts=\"%s\"", obj->subparts);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</SEGMENT>\n");
}

struct dasepSegment *dasepSegmentLoad(char *fileName)
/* Load dasepSegment from file. */
{
struct dasepSegment *obj;
xapParseAny(fileName, "SEGMENT", dasepStartHandler, dasepEndHandler, NULL, &obj);
return obj;
}

void *dasepStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASEP"))
    {
    struct dasepDasep *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "ENTRY_POINTS"))
    {
    struct dasepEntryPoints *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "href"))
            obj->href = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (obj->href == NULL)
        xapError(xp, "missing href");
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASEP"))
            {
            struct dasepDasep *parent = st->object;
            slAddHead(&parent->dasepEntryPoints, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dasepSegment *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = cloneString(val);
        else if (sameString(name, "stop"))
            obj->stop = cloneString(val);
        else if (sameString(name, "orientation"))
            obj->orientation = cloneString(val);
        else if (sameString(name, "subparts"))
            obj->subparts = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->start == NULL)
        xapError(xp, "missing start");
    if (obj->stop == NULL)
        xapError(xp, "missing stop");
    if (obj->orientation == NULL)
        xapError(xp, "missing orientation");
    if (depth > 1)
        {
        if  (sameString(st->elName, "ENTRY_POINTS"))
            {
            struct dasepEntryPoints *parent = st->object;
            slAddHead(&parent->dasepSegment, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dasepEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASEP"))
    {
    struct dasepDasep *obj = stack->object;
    if (obj->dasepEntryPoints == NULL)
        xapError(xp, "Missing ENTRY_POINTS");
    if (obj->dasepEntryPoints->next != NULL)
        xapError(xp, "Multiple ENTRY_POINTS");
    }
else if (sameString(name, "ENTRY_POINTS"))
    {
    struct dasepEntryPoints *obj = stack->object;
    slReverse(&obj->dasepSegment);
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dasepSegment *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

